#! /usr/bin/env python3
import sys
import os
import csv
from random import random
from pprint import pprint as pp

params = {"layers":[57, int(57/2), 1], "test":"TestX.csv", "train":"Train.csv"}

def getData(srcF, isTrain=True, addBias=True):
    X,y=[],[]
    with open(srcF) as src:
        reader = csv.reader(src, delimiter=',')
        for i,row in enumerate(reader):
            temp = []
            if addBias:
                temp.append(1)
            end = -1 if isTrain else len(row)
            temp.extend(row[:end])
            
            #correct data type
            X.append([x for x in map(float, temp)])

            if isTrain:
                y.append(int(row[-1]))

    return (X,y)

def getMatrix(r, c, vec):
    mat = []
    for i in range(r):
        temp = []
        for j in range(c):
            idx = i*(c)+j
            temp.append(vec[j])
        mat.append(temp)

    return mat



def cost(li, lh, lo, weights, X, y):
    w1t = weights[:(li+1)*lh]    #28x58
    w2t = weights[(li+1)*lh:]    #1x29

    w1,w2 = getMatrix(lh, li+1, w1t), getMatrix(lo, lh+1, w2t)   

    





if __name__ == "__main__":
    X,y = getData(params["train"])
    # tX,ty = getData(params["test"], isTrain=False)
    print(len(X), len(X[0]), len(y), X[0])
    li,lh,lo = tuple(params["layers"])
    weights = [random() for _ in range(lh*(li+1)+lo*(lh+1))]
    w1,w2 = cost(li, lh, lo, weights, X, y)
    #print(len(w1), len(w1[0]), len(w2), len(w2[0]))